﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using Microsoft.Win32;
using System.Diagnostics;
using System.Deployment.Application;
using System.Reflection;


namespace StartMenuShortcutCopy
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        string startmenupath = "";

        // 경로 보여주기
        private void button1_Click(object sender, EventArgs e)
        {
            startmenupath = Environment.GetFolderPath(Environment.SpecialFolder.StartMenu);
            MessageBox.Show(startmenupath.ToString());
        }

        // 시작메뉴에 아이콘 복사하기
        private void button2_Click(object sender, EventArgs e)
        {
            //manage_startupAutoRun("copy");
            //CheckForShortcut();

            CreateWindowsStartup(true);
        }

        private void CreateWindowsStartup(bool create)
        {
            string startupFileName = Environment.GetFolderPath(System.Environment.SpecialFolder.Startup) + "\\" + Application.ProductName + ".appref-ms"; 
            //string applicationShortcut = ApplicationDeployment.CurrentDeployment.ActivationUri.ToString();
            string applicationShortcut = "http://아이피:8080/Messenger/Messenger.application#Messenger.application, Culture=neutral, PublicKeyToken=0000000000000000, processorArchitecture=msil";
        
            if (create)
            {
                if (!File.Exists(startupFileName))
                {
                    using (FileStream fs = new FileStream(startupFileName, FileMode.Create))
                    {
                        using (StreamWriter sw = new StreamWriter(fs, Encoding.Unicode))
                        {
                            sw.WriteLine(applicationShortcut);
                        }
                    }
                }
            }
            else
            {
                if (File.Exists(startupFileName))
                {
                    File.Delete(startupFileName);
                }
            }
        }
        static void CheckForShortcut()
        {
            if (System.Deployment.Application.ApplicationDeployment.IsNetworkDeployed)
            {
                ApplicationDeployment ad = ApplicationDeployment.CurrentDeployment;
                if (ad.IsFirstRun)  //first time user has run the app since installation or update
                {
                    Assembly code = Assembly.GetExecutingAssembly();
                    string company = string.Empty;
                    string description = string.Empty;
                    if (Attribute.IsDefined(code, typeof(AssemblyCompanyAttribute)))
                    {
                        AssemblyCompanyAttribute ascompany =
                            (AssemblyCompanyAttribute)Attribute.GetCustomAttribute(code,
                            typeof(AssemblyCompanyAttribute));
                        company = ascompany.Company;
                    }
                    if (Attribute.IsDefined(code, typeof(AssemblyDescriptionAttribute)))
                    {
                        AssemblyDescriptionAttribute asdescription =
                            (AssemblyDescriptionAttribute)Attribute.GetCustomAttribute(code,
                            typeof(AssemblyDescriptionAttribute));
                        description = asdescription.Description;
                    }
                    if (company != string.Empty && description != string.Empty)
                    {
                        string desktopPath = string.Empty;
                        desktopPath = string.Concat(
                            Environment.GetFolderPath(Environment.SpecialFolder.Desktop),
                            "\\", description, ".appref-ms");
                        string shortcutName = string.Empty;
                        shortcutName = string.Concat(
                            Environment.GetFolderPath(Environment.SpecialFolder.Programs),
                            "\\", company, "\\", description, ".appref-ms");
                        System.IO.File.Copy(shortcutName, desktopPath, true);
                    }
                }
            }
        }

        private void manage_startupAutoRun(string action)
        {
            string startMenu_FolderName = "회사명(주)";
            if (string.IsNullOrEmpty(startMenu_FolderName)) 
                startMenu_FolderName = "메신저"; //NOTE: startMenu_FolderName must be set to the value of Project Properties > Publish Tab > Options button > Publisher Name field
            //string app_program_file = Environment.GetFolderPath(System.Environment.SpecialFolder.Programs) + "\\" + startMenu_FolderName + "\\" + Application.ProductName + ".appref-ms";
            string app_program_file = Environment.GetFolderPath(System.Environment.SpecialFolder.Programs) + "\\" + startMenu_FolderName + "\\" + "메신저\\메신저.appref-ms";
            bool app_program_file_exists = System.IO.File.Exists(app_program_file);
            string startup_file = Environment.GetFolderPath(System.Environment.SpecialFolder.Startup) + "\\" + Application.ProductName + ".appref-ms";
            bool startup_file_exists = File.Exists(startup_file);
            startMenu_FolderName = string.Empty;
            switch (action)
            {
                case "delete":
                    //remove application reference shortcut
                    if (startup_file_exists) File.Delete(startup_file);
                    break;
                case "copy":
                    if ((app_program_file_exists) && (!startup_file_exists)) 
                        File.Copy(app_program_file, startup_file);
                    //copy application reference shortcut
                    break;
                default:
                    throw new Exception("An invalid paramater [" + action + "] was passed to the manage_startupAutoRun method: accepts \"copy\" or \"delete\"");
                    break;
            }
        }


        private void shortcutCreate2()
        {

        }

        private void shortcutCreate1()
        {
            string deskDir = Environment.GetFolderPath(Environment.SpecialFolder.StartMenu);
            string linkName = "test1";

            try
            {
                using (StreamWriter writer = new StreamWriter(deskDir + "\\" + linkName + ".url"))
                {
                    string app = System.Reflection.Assembly.GetExecutingAssembly().Location;
                    writer.WriteLine("[InternetShortcut]");
                    //writer.WriteLine("URL=file:///" + app);
                    writer.WriteLine("URL=http://210.205.58.17:8080/messenger/");


                    writer.WriteLine("IconIndex=0");
                    string icon = app.Replace('\\', '/');
                    writer.WriteLine("IconFile=" + icon);
                    writer.Flush();
                }


            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }
    }
}
